<?php
class INFINEXIA_GATEWAY_HOOKS
{
	public function __construct()
	{
		add_filter('woocommerce_payment_gateways', array($this, 'add_gateway'));
		add_action('plugins_loaded', array($this, 'load_paiement_class'));;
		add_action("wp_head", array($this, "addJsVariable"));
		add_action("admin_footer", array($this, "admin_footer"));

		add_action('woocommerce_cart_calculate_fees', array($this, 'set_gateway_fee'), 10, 1);
		add_action('woocommerce_thankyou', array($this, 'checkStatus'), 10, 1);
		add_action('infinexia_gateway_check_transaction_status', array($this, 'infinexia_gateway_check_transaction_status'), 10, 1);
		add_action("wp_head", array($this, "add_chekout_js"));
	}

	function checkStatus($order_id)
	{
		$order = wc_get_order($order_id);
		if ($order != null && $order->get_payment_method() == 'infinexia') {
			do_action('infinexia_gateway_check_transaction_status', $order->get_id());
		}
	}

	function infinexia_gateway_check_transaction_status($order_id)
	{
		$order = wc_get_order($order_id);
		if ($order != null && $order->get_payment_method() == 'infinexia') {
			INFINEXIA_GATEWAY_Helpers::checkStatus($order);
		}
	}

	public function addJsVariable()
	{
		?>
			<script>
				jQuery(document).on("change", "input[name^='payment_method']", function() {
					$('body').trigger('update_checkout');
				});
			</script>
			<script src="<?php echo INFINEXIA_GATEWAY_URL."/asset/js/select2.js" ?>"></script>
		<?php
	}

	public function admin_footer()
	{
	?>
			<script src="<?php echo INFINEXIA_GATEWAY_URL."/asset/js/select2.js" ?>"></script>
		<style>
			.kl-img {
				margin: -13px;
				margin-left: -1px;
				margin-right: 10px;

			}

			.kl-input,
			.select2-container {
				width: 100% !important
			}
		</style>
	
		<script>
			var $ = jQuery;
			jQuery(".kl-select.kl-input").select3({
				templateResult: function(idioma) {


					if (idioma.id == undefined) {
                        
						return idioma.text;
					} else {

						var txt = idioma.text;
						var tab_ = txt.split("***");
						var img = idioma.element.dataset.imgSrc;
						if (tab_.length == 2) {

							var $span = $("<span><img class='kl-img' src = '" + tab_[0] + "' width='35px'> " + tab_[1] + "</span>");
							return $span;




						} else {
							return idioma.text
						}

					}

				},
				templateSelection: function(idioma) {

					if (idioma.id == undefined) {
						return idioma.text;
					} else {
						var txt = idioma.text;
						
						var tab_ = txt.split("***");

						if (tab_.length == 2) {

							var span = tab_[1];
                            
                            return span;
							var $span = $("<span><img class='kl-img' src = '" + tab_[0] + "' width='35px'> " + tab_[1] + "</span>");
							return $span;


						} else {
							return idioma.text
						}

					}
				}
			});
		</script>
		<?php
	}

	function add_gateway($gateways)
	{
		$gateways[] = 'INFINEXIA_Gateway_Paiement';

		return $gateways;
	}

	function load_paiement_class()
	{
		include_once INFINEXIA_GATEWAY_DIR . '/classes/payment-gateway.php';
	}



	function set_gateway_fee($cart)
	{
		if (is_admin() && !defined('DOING_AJAX'))
			return;

		if (!(is_checkout() && !is_wc_endpoint_url('order-received')))
			return;

		if (!is_user_logged_in())
			return;

		$payment_method = WC()->session->get('chosen_payment_method');

		if ($payment_method == 'infinexia') {
			$gateways = WC()->payment_gateways->get_available_payment_gateways();
			$gateway = $gateways['infinexia'];


			$frais = floatval($gateway->get_option('frais'));
			if ($frais > 0) {
				$percentage = $frais / 100;
				$surcharge = (WC()->cart->cart_contents_total + WC()->cart->shipping_total) * $percentage;
				$cart->add_fee('Frais', $surcharge, true);
			}
		}
	}

	function add_chekout_js()
	{
		if (is_checkout()) {
		?>
			<style>
				.kl-verticaly-align{
					margin: 0;
					position: absolute;
					top: 50%;
					-ms-transform: translateY(-50%);
					transform: translateY(-50%);
				}
			</style>
			<script>
				var $ = jQuery;

				function select2SelectWallet() {
					jQuery('.kl-select-wallet').select3({

						templateResult: function(idioma) {
							
							if (idioma.id == undefined) {
								
								return idioma.text;
							} else {
								var img = idioma.element.dataset.imgSrc;
								

								if (img != undefined) {
									var span = jQuery("<span><img class='kl-width' style='margin-top : 0px !important' src='" + img + "'/> " + idioma.text + "</span>");
									return span;

								} else {
									return idioma.text
								}

							}

						},
						templateSelection: function(idioma) {
							
							var selector = 'option[value= ' + idioma.id + ']';
							if (idioma.id == undefined) {
								return idioma.text;
							} else {

								var img = idioma.element.dataset.imgSrc;

								if (img != undefined) {
									var span = jQuery("<span class='kl-verticaly-align'><img class='kl-width'  src='" + img + "'/> " + idioma.text + "</span>");
									return span;

								} else {
									return idioma.text
								}
							}
						}
					});
				}
			</script>
<?php
		}
	}
}

new INFINEXIA_GATEWAY_HOOKS();