<?php
class INFINEXIA_GATEWAY_Helpers
{
	public static function  checkStatus($order){
		if($order->has_status('completed') || $order->has_status('cancelled')) return ;
		$data = get_post_meta($order->get_id(),"infinexia_payment_token",true);
		$app = self::getCredentials();
		$curl = curl_init();

		$curl = curl_init();

		curl_setopt_array($curl, array(
		CURLOPT_URL => INFINEXIA_PLATEFORM_URL.'/payment/check-status',
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_ENCODING => '',
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 0,
		CURLOPT_FOLLOWLOCATION => true,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => 'POST',
		CURLOPT_POSTFIELDS =>'{
		"transaction_id": "'.$data['transaction_id'].'"
		}',
		CURLOPT_HTTPHEADER => array(
			'App-id: '.$app['merchant'],
			'App-key: '.$app['key'],
			'Content-Type: application/json'
		),
		));


		$useragent = 'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:17.0) Gecko/20100101 Firefox/17.0';

		curl_setopt($curl, CURLOPT_USERAGENT, $useragent);
		curl_setopt($curl, CURLOPT_REFERER,get_site_url());
		

		$response = curl_exec($curl);

		curl_close($curl);
		$response = json_decode($response,true);

		if($response != null && isset($response["status"])){
			if($response["status"] == "completed"){
				$order->update_status("completed");
			}
			else if($response["status"] == "canceled"){
				$order->update_status("cancelled");
			}
		}
		
	}

	public static function getAvailaibleWallet($wallets, $type = "fiat"){
		$data = [];
		foreach($wallets as $wallet){
			if($wallet["type"] != $type) continue;
			$url = INFINEXIA_SITE_URL."/". $wallet['logo'];
			$data[$wallet["abbr"]] = "{$url}***".$wallet["name"] ;
		}
		
		return $data;
	}

	public static function getData($app_id, $app_key){
		


        $curl = curl_init();

        curl_setopt_array($curl, array(
        CURLOPT_URL => INFINEXIA_PLATEFORM_URL.'/payment',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'App-Id: '.$app_id,
            'app-key: '.$app_key
        ),
        ));
        $response = curl_exec($curl);
       
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $response = json_decode($response,true);

        
        if($response != null && $http_code === 200){
            return $response;
        }
        else return [
            "assets" => [],
            "fee" => 2.5
        ];
    }

	public static function initialize_payment($order_id){
		$app = self::getCredentials();

		$data = self::getPaymentData($order_id);
	
        $transaction_id = $data["transaction_id"];
        $wallet_id = $data["wallet_id"];
        $amount = $data["amount"];
        $call_back_url = $data["call_back_url"];
        $success_url = $data["success_url"];
        $fail_url = $data["fail_url"];
        $currency = $data["currency"];
        $description = "Payment for order number ".$order_id;
        $json_data = ["order_id" => $order_id , "amount" => $amount , "currency" => $currency];
        $payee_name = get_bloginfo();	
		
		

		$curl = curl_init();

			curl_setopt_array($curl, array(
			CURLOPT_URL => INFINEXIA_PLATEFORM_URL.'/payment/initialize',
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => '',
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 0,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => 'POST',
			CURLOPT_POSTFIELDS =>'{
			"transaction_id": "'.$transaction_id.'",
			"wallet": "'.$wallet_id.'",
			"amount": '.$amount.',
			"call_back_url": "'.$call_back_url.'",
			"success_url": "'.$success_url.'",
			"fail_url": "'.$fail_url.'",
			"description": "'.$description.'",
			"json_data": "",
			"payee_name": "'.$payee_name.'",
			"currency": "'.$currency.'",
			"reference": "#'.$order_id.'"
			}',
			CURLOPT_HTTPHEADER => array(
				'App-id: '.$app['merchant'],
				'App-key: '.$app['key'],
				'Content-Type: application/json'
			),
			));


		$useragent = 'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:17.0) Gecko/20100101 Firefox/17.0';

		curl_setopt($curl, CURLOPT_USERAGENT, $useragent);
		curl_setopt($curl, CURLOPT_REFERER,get_site_url());
		

		$response = curl_exec($curl);
	
		curl_close($curl);
		$response = json_decode($response,true);
		
		return $response;
	}

	public static function savePaymentData($order_id,$wallet_id,$call_back_url,$success_url,$fail_url){
        $order = wc_get_order( $order_id );
		$transaction_id =  "INF-".mt_rand(1,1000)."-".strtoupper(uniqid()."".$order_id);
		$data = [
            "transaction_id" =>$transaction_id ,
            "amount" => $order->get_total(),
            "currency" => $order->get_currency(),
			"wallet_id" => $wallet_id,
			"call_back_url" => $call_back_url,
			"success_url" => $success_url,
			"fail_url" => $fail_url
        ];
		
		update_post_meta($order_id,"infinexia_payment_data",$data);

		return $transaction_id ;
	}

	public static function getPaymentData($order_id){
		return get_post_meta($order_id,"infinexia_payment_data",true);
	}

	public static function getCredentials(){
		$gateways = WC()->payment_gateways->get_available_payment_gateways();
		$kaly = $gateways['infinexia'];
		if($kaly != null){
			return [
				'merchant' => $kaly->get_option("merchant_id"),
				"key" => $kaly->get_option("api_key"),
			];
		}
		else{
			return [
				'merchant' => null,
				"key" => null
			];
		}
	}
}