<?php
/**
* Plugin Name: Infinexia Gateway for Woocommerce
* Description: Accept payments from your WooCommerce easily and securely via Infinexia.
* Version: 1.0.0
* Author: Infinexia
* Author URI:  https://www.infinexia.com/
* Text Domain: infinexia-gateway
*/
if (!function_exists('add_action')) {
    header("HTTP/1.0 404 Not Found");
    exit;
}
define('INFINEXIA_GATEWAY_URL', plugins_url('', __FILE__));
define('INFINEXIA_GATEWAY_DIR', plugin_dir_path(__FILE__));

define('INFINEXIA_PLATEFORM_URL', "https://api.infinexia.com");
define('INFINEXIA_SITE_URL', "https://infinexia.com");



include_once(ABSPATH . 'wp-includes/pluggable.php');
require_once(ABSPATH . 'wp-admin/includes/upgrade.php');


function load_infinexia_textdomain() {
    load_plugin_textdomain( 'infinexia-gateway', true, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
}
add_action( 'plugins_loaded', 'load_infinexia_textdomain' );


add_action( 'admin_init', 'infinexia_plugin_has_parent_plugin' );
function infinexia_plugin_has_parent_plugin() {
    if ( is_admin() && current_user_can( 'activate_plugins' ) &&  !is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
        add_action( 'admin_notices', 'infinexia_need_woocommerce_notice' );

        deactivate_plugins( plugin_basename( __FILE__ ) ); 

        if ( isset( $_GET['activate'] ) ) {
            unset( $_GET['activate'] );
        }
    }
}


function woocommerce_infinexia_plugin_links( $links ) {
	$setting_link = admin_url('admin.php?page=wc-settings&tab=checkout&section=infinexia');
	$plugin_links = array(
		'<a href="' . $setting_link . '">' . __('Settings', 'infinexia-gateway-for-woocommerce') . '</a>',
		'<a href="https://infinexia.tawk.help/">' . __( 'Support', 'infinexia-gateway-for-woocommerce' ) . '</a>',
		'<a href="https://infinexia.com/documentation/introduction">' . __( 'Docs', 'infinexia-for-woocommerce' ) . '</a>',
	);

	return array_merge( $plugin_links, $links );
}

add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'woocommerce_infinexia_plugin_links' );


function infinexia_need_woocommerce_notice(){
    ?><div class="error"><p>Infinexia gateway a besoin de Woocommerce pour fonctionner.</p></div><?php
}



if(is_plugin_active( 'woocommerce/woocommerce.php' )){

     include_once(INFINEXIA_GATEWAY_DIR.'/classes/setting.php');
     $setting = new INFINEXIA_GATEWAY_Setting();
    
}